def gv

pipeline { //must be on top-level
    agent any // where to execute
    tools {
        maven 'maven-3.9' //in 'Manage Jenkins > Global Tool Configuration, we installed maven and named it, use that name'
    }
    stages {  //where the 'work' happens
        stage("init") {
            steps {
                script {
                    gv = load "script.groovy"
                    echo "test webhook"
                }
            }
        }
        stage("build jar") {
            //when {
                //expression {
                    //BRANCH_NAME == 'main' 
                    //BRANCH_NAME is an environmental variable only available in multi-branch pipeline
                    // it holds the value of which branch is being checked out currently
               // }
            //}
            steps {
                script {
                    //echo "building jar"
                    gv.buildJar()
                    //echo "Executing pipeline for branch $BRANCH_NAME"
                }
            }
        }
        stage("build image") {
            // when {
            //     expression {
            //         BRANCH_NAME == 'main' 
            //         //BRANCH_NAME is an environmental variable only available in multi-branch pipeline
            //         // it holds the value of which branch is being checked out currently
            //     }
            // }
            steps {
                script {
                    //echo "building image"
                    gv.buildImage()
                }
            }
        }
        stage("deploy") {
            // when {
            //     expression {
            //         BRANCH_NAME == 'main' 
            //         //BRANCH_NAME is an environmental variable only available in multi-branch pipeline
            //         // it holds the value of which branch is being checked out currently
            //     }
            // }
            steps {
                script {
                    echo "deploying"
                    //gv.deployApp()
                }
            }
        }
    }   
}